#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>

// Format savedata.exe DataFilePathCsv ItemCol1 ItemCol2 [ItemCol3] [ItemCol4] [ItemCol...]

// ** GetCommaDelString

void GetCommaDelString(const char* szInString, size_t& iidx, char* szOutString, size_t maxstr)
{
	size_t oidx = 0;
	maxstr--;
	while (true) {
		char c = szInString[iidx];
		if ((c == 0) || (c == ',') || (c == '\n') || (c == '\r')) {
			if (c == ',') iidx++;
			szOutString[oidx] = 0;
			return;
		}
		iidx++;
		if (oidx < maxstr) szOutString[oidx++] = c;
	}
}

// ** TrimString

void TrimString(char* szString)
{
	size_t ist = 0;
	while (szString[ist] == ' ') ist++;
	if (ist) {
		int ost = 0;
		char c;
		do {
			c = szString[ist++];
			szString[ost++] = c;
		} while (c);
	}
	
	size_t ien = strlen(szString);
	while ((ien > 0) && (szString[ien - 1] == ' ')) ien--;
	szString[ien] = 0;
}

// ** TempFileName

void TempFileName(char* szString)
{
	int pos;
	char *pdest;
	
	pdest = strchr(szString, '.');
	pos = pdest - szString;
	if(pdest != NULL)
		szString[pos] = 0;
	strcat(szString,".tmp");
}

int main(int argc, char *argv[], char *[])
{
	setvbuf(stdout, NULL, _IONBF, 0);
	const char* szCopyright = "copyright=NCH Swift Sound";
	int retval=1;
	
	if (argc > 2) {
		char szValue[256], szTempFile[256], tmpLine[512];
		strcpy(szValue, argv[2]);
		TrimString(szValue);
		strcpy(szTempFile, argv[1]);
		TempFileName(szTempFile);
		
		FILE* fh;
		FILE* ft = fopen(szTempFile, "w");
		int cntr=0;
		time_t szSTime,szCTime;
		
		printf("%s\n",szCopyright);

		while(!(fh = fopen(argv[1], "r")) && cntr<5){
			time(&szSTime);
			time(&szCTime);
			while(difftime(szCTime, szSTime)<1)
				time(&szCTime);
			cntr++;
		}
		
		
		if(!fh)
			fh = fopen(argv[1],"w+");
		
		if(fh && ft){
			while (!feof(fh)) {
				size_t idx = 0;
				char szLine[512];
				if (fgets(szLine, 512, fh) == NULL) break;
				strcpy(tmpLine,szLine);
				if(retval == 1) {
					char szCurrentValue[256];
					GetCommaDelString(szLine, idx, szCurrentValue, sizeof szCurrentValue);
					TrimString(szCurrentValue);
					if (stricmp(szCurrentValue, szValue) == 0) {
						strcpy(tmpLine, szValue);
						for(int i=3;i<argc;i++){
							strcat(tmpLine, ",");
							strcat(tmpLine, argv[i]);
						}
						strcat(tmpLine, "\n");
						retval = 0;
					}
				}
				if(fputs(tmpLine, ft)<0) {
					fclose(fh);
					fclose(ft);
					printf("error - writing to file");
					return 1;
				}
			}
			if(retval==1){
				strcpy(tmpLine, "");
				for(int i=2;i<argc;i++){
					if(i!=2) strcat(tmpLine, ",");
					strcat(tmpLine, argv[i]);
				}
				strcat(tmpLine, "\n");
				if(fputs(tmpLine, ft)>=0)
					retval=0;
			}
			fclose(fh);
			fclose(ft);
			if(retval==0 && remove(argv[1])==0)
				rename(szTempFile, argv[1]);
			return retval;
		}
		else{
			if(ft)
				fclose(ft);
			if(fh)
				fclose(fh);
			printf("error - cannot open file");
			return 1;
		}
	}
	printf("error - insufficient arguments");
	return 1;
}
